#!/usr/bin/perl

#batch process segmentation and aligning
#create text file, tab delimited with the following:
#<sourceFile> [tab] <labels>
#each line represents a new file to be segmented and aligned
#have as many lines as necessary
#script will go through the whole text file and execute line by line

$batchFile = @ARGV[0];

if (($#ARGV + 1) != 1)
{
  print "\nThis script does batch segmentation\n";
  print "\nUsage: perl ./segment-batch.pl batchTextFile.txt\n\n";
  exit(0);
}

#fix line endings
#$cmd = "perl -pi -e 's/\r/\n/g' " . $batchFile;
#system($cmd);

open(BATCH, $batchFile) or die "Error opening batch file";



$source = "";
$targetNameList = "";
#$targetTransList = "";
#$speechChannel = "";
#$phoneticAlign = "";
#$userDictionaryPath = "";

$currentLine = 1;
$totalLines = 0;
while(<BATCH>){
	$totalLines +=1;
}
close BATCH;

open(BATCH, $batchFile) or die "Error opening batch file";
while(<BATCH>){
	$line = $_;
	
	#chomp($line);
	#convert CRLF (windows line feed) to LF (mac compatible line feed)
	#$line =~ s/(\r\n|\r|\n)//;
	
#	if($line=~ m/(.+)\t(.+)\t(.+)\t(.+)\t(.+)\t(.+)/){
	if($line=~ m/(.+)\t(.+)/){
			$source =  $1;
			$targetNameList =  $2;
#			$targetTransList =  $3;
#			$speechChannel =  $4;
#			$phoneticAlign =  $5;
#		if($6!=-1){
#			$userDictionaryPath =  $6;
#		} else {
#			$userDictionaryPath =  '';
#		}
		$cmd = "perl segment.pl \'" . $source . "\' \'" . $targetNameList . "\'";
		#$cmd = "perl segment-align.pl \'" . $source . "\' \'" . $targetNameList . "\' \'" . $targetTransList . "\' \'" . $speechChannel . "\' \'" . $phoneticAlign . "\' \'" . $userDictionaryPath . "\'";
		print "Batch aligning file " . $currentLine . " of " . $totalLines . "\n";
		print $cmd . "\n";
		system($cmd);
	} else {
		print "error in batch file on line " . $currentLine . "\n";
	}
	
	$currentLine +=1;
}