#!/usr/bin/perl

#segment-align master file
#this script makes use of extractMono.pl, createTstamp.pl, segmentAudio2.pl, createRaw.pl, batchAlign.pl and aligner.pl
#segments audio from a TriggerWave file and then aligns it

#$soxPath = @ARGV[0]; #path to sox command

$source = @ARGV[0]; #filename and path to source stereo wavefile
$targetNameList = @ARGV[1]; #path and filename to label text file
#$targetTransList = @ARGV[2]; #path and filename to transcription text file

if (($#ARGV + 1) != 2)
{
  print "\nThis script segments a triggerwave audio file.\n";
  print "\nUsage: perl ./segment.pl sourceFile labels\n\n";
  exit(0);
}


#first fix possible line break issues
#$cmd = "perl -pi -e 's/\r/\n/g' " . $targetNameList;
#system($cmd);
#$cmd = "perl -pi -e 's/\r/\n/g' " . $targetTransList;
#system($cmd);


$cmd1 = "perl ./extractMono.pl ./ \'" . $source . "\'";
#print "CMD1: " . $cmd1 . "\n";
print "Separating channels...\n";
system($cmd1);
print "Finished separating channels\n\n";

if($speechChannel==0){
	$speechSource = substr($source, 0, rindex($source, '/')) . "/_left.wav"; #filename and path to source mono wavefile that contains speech
	$triggerSource = substr($source, 0, rindex($source, '/')) . "/_right.wav"; #filename and path to source mono wavefile that contains triggers
	$cmd2 = "perl ./createTstamp.pl ./ \'" . $triggerSource . "\'";
} else {
	$speechSource = substr($source, 0, rindex($source, '/')) . "/_right.wav";
	$triggerSource = substr($source, 0, rindex($source, '/')) . "/_left.wav";
	$cmd2 = "perl ./createTstamp ./ \'" . $triggerSource . "\'";
}
#print "CMD2: " . $cmd2 . "\n";
print "Creating Time Stamps...\n";
system($cmd2);
print "Finished creating Time Stamps\n\n";

$timeList = substr($source, 0, rindex($source, '/')) . "/_tStamp.trg"; #path and filename to tStamp text file (_tStamp.trg)
$cmd3 = "perl ./segmentAudio2.pl ./ \'" . $speechSource . "\' \'" . $source . "\' \'" . $targetNameList . "\' \'" . $timeList . "\'";
#$cmd3 = "perl ./segmentAudio2.pl ./ \'" . $speechSource . "\' \'" . $source . "\' \'" . $targetNameList . "\' \'" . $targetTransList . "\' \'" . $timeList . "\'";
#print "CMD3: " . $cmd3 . "\n";
print "Segmenting Audio...\n";
print "CMD3:" . $cmd3 . "\n\n";
system($cmd3);
print "Segmentation Complete              \n\n";

# 
# $segmentsFolder =  substr($source, 0, rindex($source, '.')) . "/"; #path to folder that contains audio segments
# 
# $cmd4 = "perl ./createRaw.pl ./ \'" . $segmentsFolder . "\'";
# #print "CMD4: " . $cmd4 . "\n";
# print "Creating .raw audio...\n";
# system($cmd4);
# print "Creation of .raw audio complete\n\n";
# 
# $cmd5 = "perl ./batchAlign.pl ./ \'" . $segmentsFolder . "\' './sonic/' 8000 " . $phoneticAlign . " \'" . $userDictionaryPath . "\'"; 
# #print "CMD5: " . $cmd5 . "\n";
# print "Aligning...\n";
# system($cmd5);
# print "Aligning complete                    \n\n";

#delete temp files
if($speechChannel==0){
	$oldName = substr($source, 0, rindex($source, '/')) . "/_left.wav";
	$newName = substr($source, 0, rindex($source, '.')) . "-l.wav";
	rename($oldName, $newName);
	unlink substr($source, 0, rindex($source, '/')) . "/_right.wav";
} else {
	$oldName = substr($source, 0, rindex($source, '/')) . "/_right.wav";
	$newName = substr($source, 0, rindex($source, '.')) . "-r.wav";
	unlink substr($source, 0, rindex($source, '/')) . "/_left.wav";
}

unlink substr($source, 0, rindex($source, '/')) . "/_tStamp.trg";

# print "Deleting old text and raw files...\n";
# opendir(DIR, $segmentsFolder) or die "can't open $segmentsFolder : $!";
# @TEXTFILES =  grep /\.txt$/, readdir DIR;
# closedir DIR;
# foreach(@TEXTFILES){
# 	$currentFile = $_;
# 	chomp($currentFile);
# 	unlink ($segmentsFolder . $currentFile);
# 	unlink ($segmentsFolder . substr($currentFile, 0, rindex($currentFile, ".")) . ".raw");
# }
# print "Finished deleting old text and raw files\n\n";

print "Done!\n";