#!/usr/bin/perl
use File::Path;
use IO::Handle;

autoflush STDERR,1;

#STEP 3
#This script segments a mono audio file based on the _tStamp.trg timestamps
#segmented audio files are placed in a new folder that is named after the original stereo source audiofile

$soxPath = @ARGV[0]; #path to sox command
$sourcePathFilename = @ARGV[1]; #path and filename to mono wavefile that contains speech
$stereoSource = @ARGV[2]; #path and filename to original stereo audio file
$targetNameList = @ARGV[3]; #path and filename to label text file
#$targetTransList = @ARGV[4]; #path and filename to transcription text file
$timeList = @ARGV[4]; #path and filename to tStamp text file

if (($#ARGV + 1) != 5)
{
  print "\nThis script segments a mono audio file based on the _tStamp.trg timestamps.\n";
  print "Segmented audio files are placed in a new folder that is named after the original stereo source audiofile\n";
  print "\nUsage: perl ./segmentAudio2.pl pathToSox speechSourcePathAndFilename originalStereoSourcePathAndFilename labelsTextFile timeStampPathAndFilename\n\n";
  exit(0);
}

#$targetFolderPath = @ARGV[4]; #path to folder for saving segments
$targetFolderPath = substr($stereoSource, 0, rindex($stereoSource, '.')) . "/";#path to stereo source file. extracted from $source

print "TARGET FOLDER PATH:" . $targetFolderPath . "\n\n";
#$sourceFilename = substr($sourcePathFilename, length($targetFolderPath), length($sourcePathFilename));#just the audio filename
#$folderName = substr($stereoSource, 0, rindex($stereoSource, ".")) . "/";#folder name = audio filename without the .wav extension

#$targetFolderPath .= $folderName;
if(-e $targetFolderPath){
	print "deleting original folder...\n";
	rmtree($targetFolderPath, 0 ,1);
	mkdir $targetFolderPath; #create folder to put all the audio segments in
} else {
	mkdir $targetFolderPath; #create folder to put all the audio segments in
}
#print "TARGET: " . $targetFolderPath . "\n";

#print $sourcePathFilename . "\n";
#open timeList
open(TIMELIST, $timeList) or die "Error opening tStamps";

@timeArray = [];
@timeArray=<TIMELIST>; #assign each line of the text file to @timeArray
chomp(@timeArray); #remove the newline character
pop(@timeArray); #remove the last "!n!" character
close(TIMELIST);

# Extract the audio file length
$audioLength = 0.0;
$soxcmd = "\'" .$soxPath . "sox\' \'" . $sourcePathFilename . "\' -e stat 2>&1";

#print $soxcmd . "\n";
$soxres = `$soxcmd`;
if ($soxres =~ /.*\(seconds\):\W+([0-9\.]+)\n.*/){
	$audioLength = $1;
	#print $audioLength . "\n";
} else {
	print "Audio length not found!\n";
	print "Soxres was: $soxres\n";
	exit(0);
}
push(@timeArray, $audioLength);


#open labels
open(LABELS, $targetNameList) or die "Error opening labels";
#open(TRANS, $targetTransList) or die "Error opening labels";
$index = 0;
$length = 0;
$arrayLength = @timeArray;
#$arrayLength = $arrayLength - 1;
while($line = <LABELS>){
	
	#chomp($line);
	#convert CRLF (windows line feed) to LF (mac compatible line feed)
	#$line =~ s/(\r\n|\r|\n)//;
	
	if($line =~ m/(.+)/){
		$length = @timeArray[$index+1] - @timeArray[$index];
		$cmd = "\'" . $soxPath . "\sox' \'" . $sourcePathFilename . "\' \'" . $targetFolderPath . $1 . ".wav\' trim " . @timeArray[$index] . " " . $length . "\n";
		#print ($1 . "\n");
		#print $cmd."\n";
		print STDERR "Segmenting Files: " . ($index + 1) . "/" . $arrayLength . "\r";
		`$cmd`;
		
# segment transcriptions text file
# 		$trans = <TRANS>;#line by line of the transcription text file
# 		chomp($trans);
# 		
# convert CRLF (windows line feed) to LF (mac compatible line feed)
# $trans =~ s/(\r\n|\r|\n)//;
# 
# 		$transSegPathFilename = $targetFolderPath . $1 . ".txt";
# 		open(TRANS_SEG, ">>" . $transSegPathFilename);
# 		print TRANS_SEG "0\t" . $length . "\t" . "!SIL " . $trans . " !SIL";
# print $transSegPathFilename . "\n";
# 		close(TRANS_SEG);
	}
	$index += 1;
}

close(LABELS);
#close(TRANS);
#print @labelArray;